Package com.saxonica.ee.stream.watch

## Class ForEachAction

- java.lang.Object
- - net.sf.saxon.event.Outputter
  - - net.sf.saxon.event.ProxyOutputter
    - - com.saxonica.ee.stream.feed.ItemFeed
      - - com.saxonica.ee.stream.watch.ForEachAction

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`
  Direct Known Subclasses:
    `ForEachGroupParallelAction`, `IterateAction`

      public class ForEachAction
      extends ItemFeed

  This watch implements xsl:for-each in streaming mode. It is informed of the nodes or other items selected by the xsl:for-each instruction; when such an item is encountered, it locates the relevant (inverted) action representing the body of the for-each, and activates it.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected XPathContext` | `bodyContext` |

    - ### Fields inherited from class net.sf.saxon.event.Outputter

      `pipelineConfiguration, systemId`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ForEachAction​(WatchManager watchManager, Expression expression, ItemFeed result, XPathContext context)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `append​(Item it)` | Method called by the feed for a subexpression to supply a grounded item from the streamed input.
    `void` | `close()` | Finish evaluating the expression.
    `void` | `endSelectedParentNode​(Location locationId)` | Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
    `protected Expression` | `getAction()` |
    `protected XPathContext` | `getBodyContext()` |
    `protected Inversion` | `getInversion()` |
    `protected WatchManager` | `getWatchManager()` |
    `protected boolean` | `isActionConsuming()` |
    `protected void` | `makeBodyContext()` |
    `void` | `open​(Terminator terminator)` | Start evaluating the expression.
    `void` | `setInversion​(Inversion inversion)` | Set the inversion of the for-each action (the body of the loop)
    `Receiver` | `startSelectedParentNode​(FleetingParentNode node, Location locationId)` | Signal that an element has been found that matches the selection that this Watch is looking for.

    - ### Methods inherited from class com.saxonica.ee.stream.feed.ItemFeed

      `append, dynamicError, getContext, getExpression, getResult, getTerminator, hasFailed, processItems, setExpression, setHasFailed, setTerminator`

    - ### Methods inherited from class net.sf.saxon.event.ProxyOutputter

      `attribute, characters, comment, endDocument, endElement, getNextOutputter, namespace, open, processingInstruction, setLocation, setUnparsedEntity, startContent, startDocument, startElement, startElement, usesTypeAnnotations`

    - ### Methods inherited from class net.sf.saxon.event.Outputter

      `getConfiguration, getPipelineConfiguration, getStringReceiver, getSystemId, namespaces, setPipelineConfiguration, setSystemId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.event.Receiver

      `handlesAppend`

- - ### Field Detail

    - #### bodyContext

          protected XPathContext bodyContext

  - ### Constructor Detail

    - #### ForEachAction

          public ForEachAction​(WatchManager watchManager,
                               Expression expression,
                               ItemFeed result,
                               XPathContext context)

  - ### Method Detail

    - #### setInversion

          public void setInversion​(Inversion inversion)

      Set the inversion of the for-each action (the body of the loop)
      Parameters:
        `inversion` - the inverted code implementing the body of the for-each

    - #### getInversion

          protected Inversion getInversion()

    - #### getWatchManager

          protected WatchManager getWatchManager()

    - #### getAction

          protected Expression getAction()

    - #### isActionConsuming

          protected boolean isActionConsuming()

    - #### getBodyContext

          protected XPathContext getBodyContext()

    - #### open

          public void open​(Terminator terminator)
                    throws XPathException

      Description copied from class: `ItemFeed`
      Start evaluating the expression. The default implementation does nothing.
      Overrides:
        `open` in class `ItemFeed`
      Parameters:
        `terminator` - used to achieve early exit
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### makeBodyContext

          protected void makeBodyContext()

    - #### startSelectedParentNode

          public Receiver startSelectedParentNode​(FleetingParentNode node,
                                                  Location locationId)
                                           throws XPathException

      Signal that an element has been found that matches the selection that this Watch is looking for. This method is called by the WatchManager while processing the startElement event that matches the selection. For this purpose, any attributes selected by the last step in the selection are ignored
      Overrides:
        `startSelectedParentNode` in class `ItemFeed`
      Parameters:
        `node` - the element or document node whose start event has been matched
        `locationId` - the location associated with the element or document node (may be the location of the instruction that created it)
      Returns:
        always null
      Throws:
        `ValidationException` - May be raised if the constraint implemented by this Watch is violated @param locationId the location of the node in the source, or of the instruction that created it
        `XPathException` - May be raised if a dynamic error occurs

    - #### append

          public void append​(Item it)
                      throws XPathException

      Method called by the feed for a subexpression to supply a grounded item from the streamed input.
      Specified by:
        `append` in interface `Receiver`
      Specified by:
        `append` in class `ItemFeed`
      Parameters:
        `it` - the grounded item.
      Throws:
        `XPathException` - if the operation fails

    - #### endSelectedParentNode

          public void endSelectedParentNode​(Location locationId)
                                     throws XPathException

      Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
      Overrides:
        `endSelectedParentNode` in class `ItemFeed`
      Parameters:
        `locationId` - the location of the node in the source, or of the instruction that created it
      Throws:
        `ValidationException` - May be raised if the constraint implemented by this Watch is violated @param locationId the location of the node in the source, or of the instruction that created it
        `XPathException` - May be raised if a constraint implemented by this Watch is violated

    - #### close

          public void close()
                     throws XPathException

      Description copied from class: `ItemFeed`
      Finish evaluating the expression.
      Specified by:
        `close` in interface `Receiver`
      Overrides:
        `close` in class `ItemFeed`
      Throws:
        `XPathException` - if a dynamic error occurs